# DescribeSecurityGroupRule

## 1. API Description

This API (DescribeSecurityGroupRule) is used to query the security group rules.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name  | Required | Type   | Description        |
| --------------- | -------- | ------ | ------------------ |
| securityGroupId | Yes      | String | Security group ID. |

## 3. Output Parameters

| Parameter Name  | Type                                                                                                                          | Description                                                                                                           |
| --------------- | ----------------------------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId       | String                                                                                                                        | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| ingressRuleList | Array of [SecurityGroupRuleInfo](https://docs.console.zenlayer.com/api-reference/compute/datastructure#securitygroupruleinfo) | Inbound rules.                                                                                                        |
| egressRuleList  | Array of [SecurityGroupRuleInfo](https://docs.console.zenlayer.com/api-reference/compute/datastructure#securitygroupruleinfo) | Outbound rules.                                                                                                       |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Query the security group rules.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeSecurityGroupRule
<Common Request Params>

Request:
{
  "securityGroupId": "791721259766392536"
}

Response:
{
  "requestId": "T27931ABC-1856-4928-9B82-D80C56DD4DBA",
  "response": {
    "requestId": "T27931ABC-1856-4928-9B82-D80C56DD4DBA",
    "ingressRuleList": [
      {
        "direction": "ingress",
        "ipProtocol": "all",
        "portRange": "1-65535",
        "policy": "accept",
        "priority": 1,
        "cidrIp": "0.0.0.0/0",
        "desc": "aaa"
      }
    ],
    "egressRuleList": [
      {
        "direction": "egress",
        "ipProtocol": "all",
        "portRange": "1-65535",
        "policy": "accept",
        "priority": 1,
        "cidrIp": "0.0.0.0/0",
        "desc": "xxx"
      }
    ]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).

| HTTP Status Code | Error Code                           | Description                                  |
| ---------------- | ------------------------------------ | -------------------------------------------- |
| 404              | INVALID\_SECURITY\_GROUP\_NOT\_FOUND | The specified security group does not exist. |
